---
title: MediaPositionState.duration
slug: Web/API/MediaPositionState/duration
tags:
  - API
  - Audio
  - Media
  - Media Session API
  - MediaPositionState
  - MediaSession API
  - Playback
  - Property
  - Reference
  - Time
  - Video
  - duration
  - length
---
<p>{{APIRef("Media Session API")}}</p>

<p><span class="seoSummary">The {{domxref("MediaPositionState")}} dictionary's <code><strong>duration</strong></code> property is used when calling the {{domxref("MediaSession")}} method {{domxref("MediaSession.setPositionState", "setPositionState()")}} to provide the {{Glossary("user agent")}} with the overall total duration in seconds of the media currently being performed.</span> This information can then, in turn, be used by the user agent to provide a user interface which displays media playback information to the viewer.</p>

<p>For example, a browser might use this information along with the {{domxref("MediaPositionState.position", "position")}} property and the {{domxref("MediaSession.playbackState", "navigator.mediaSession.playbackState")}}, as well as the session's {{domxref("MediaSession.metadata", "metadata")}} to provide an integrated common user interface showing the currently playing media as well as standard pause, play, forward, reverse, and other controls.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>positionState</em> = { duration: <em>durationInSeconds</em> };

let <em>durationInSeconds</em> = <em>positionState</em>.duration;
</pre>

<h3 id="Value">Value</h3>

<p>A floating-point value indicating the overall duration, in seconds, of the media being performed. This value should always be positive. To indicate media of unknown or indeterminate length, such as an ongoing live stream, specify a value of positive infinity (<code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Infinity">Infinity</a></code>).</p>

<h2 id="Example">Example</h2>

<p>In this example, an app performing a live stream provides information to the browser by preparing a {{domxref("MediaPositionState")}} object and submitting it by calling {{domxref("MediaSession.setPositionState", "navigator.mediaSession.setPositionState()")}}.</p>

<pre class="brush: js">let positionState = {
  duration: Infinity;
  playbackRate: 1.0;
  position: 0.0;
};

navigator.mediaSession.setPositionState(positionState);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Session','#dom-mediapositionstate-duration','MediaPositionState.duration')}}</td>
   <td>{{Spec2('Media Session')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.MediaPositionState.duration")}}</p>
